﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Script.Services;
using System.Web.Services;
using DotNetNuke.Common;
using DotNetNuke.Common.Utilities;
using DotNetNuke.Entities.Portals;
using DotNetNuke.Entities.Tabs;
using DotNetNuke.Entities.Users;
using DotNetNuke.Services.FileSystem;
using DotNetNuke.Services.Localization;

namespace ToSic.SexyContent.API
{
	[WebService(Namespace = "http://schemas.2sic.com/2013/ToSexyContent/Services/01.00")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	[System.ComponentModel.ToolboxItem(false)]
	[ScriptService]
	public class Services : WebService
	{
		//private readonly PortalSettings _settings;

		public Services()
		{
			//var request = HttpContext.Current.Request;
			//var domainName = Globals.GetDomainName(request);
			//var alias = PortalAliasController.GetPortalAliasInfo(domainName);

			//_settings = new PortalSettings(-1, alias);

			//throw new Exception(UserController.GetCurrentUserInfo().IsSuperUser.ToString());

			// ToDo: Enable Security Check!
			//if (!_settings.UserInfo.IsInRole(_settings.AdministratorRoleName) && !_settings.UserInfo.IsSuperUser)
			//	throw new Exception("User must be Member of " + _settings.AdministratorRoleName + " Role or SuperUser");
		}

		[WebMethod]
		[ScriptMethod(ResponseFormat = ResponseFormat.Json)]
		public FileInfo GetFileByPath(int portalId, string relativePath)
		{
			var fileManager = FileManager.Instance;
			var file = fileManager.GetFile(portalId, relativePath);

			return (FileInfo)file;
		}

		[WebMethod]
		[ScriptMethod(ResponseFormat = ResponseFormat.Json)]
		public FileInfo GetFileById(int fileId)
		{
			var fileManager = FileManager.Instance;
			var file = fileManager.GetFile(fileId);

			return (FileInfo)file;
		}

		[WebMethod]
		[ScriptMethod(ResponseFormat = ResponseFormat.Json)]
		public List<TabInfo> GetPortalTabs(int portalId, string activeLanguage)
		{
			// Source: DotNetNuke.Modules.Admin.Portals.SiteSettings.BindPages
			var listTabs = TabController.GetPortalTabs(TabController.GetTabsBySortOrder(portalId, activeLanguage, true),
													   Null.NullInteger, true,
													   "<" + Localization.GetString("None_Specified") + ">", true, false, false,
													   false, false);
			var tabs = from t in listTabs
					   where !t.DisableLink
					   select new TabInfo { IndentedTabName = t.IndentedTabName, TabID = t.TabID };

			return tabs.ToList();
		}

		public struct TabInfo
		{
			public int TabID { get; set; }
			public string IndentedTabName { get; set; }
		}
	}
}
