﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ToSic.SexyContent.ImportExport;

namespace ToSic.SexyContent
{
    public partial class Import : DotNetNuke.Entities.Modules.PortalModuleBase
    {
        SexyContent Sexy = new SexyContent();
        protected void Page_Load(object sender, EventArgs e)
        {
            hlkCancel.NavigateUrl = hlkClose.NavigateUrl = EditUrl(SexyContent.ControlKeys.ManageTemplates);
        }

        protected void btnUpload_Click(object sender, EventArgs e)
        {
            if (fileUpload.HasFile)
            {
                List<ExportImportMessage> Messages = new List<ExportImportMessage>();

                if (fileUpload.FileName.EndsWith(".zip"))
                {
                    bool Success = new ZipImport().ImportZip(fileUpload.FileContent, Server, PortalSettings, Messages);
                }
                else
                {
                    string Xml = new System.IO.StreamReader(fileUpload.FileContent).ReadToEnd();
                    bool Success = new XmlImport().ImportXml(Xml, Messages);
                }

                lstvSummary.DataSource = Messages;
                lstvSummary.DataBind();
                pnlSummary.Visible = true;
                pnlUpload.Visible = false;
            }
        }

        protected void lstvSummary_ItemDataBound(object sender, ListViewItemEventArgs e)
        {
            if (e.Item.ItemType == ListViewItemType.DataItem)
            {
                ExportImportMessage.MessageTypes MessageType = ((ExportImportMessage)e.Item.DataItem).MessageType;
                Panel Pnl = (Panel)e.Item.FindControl("pnlMessage");

                if (MessageType == ExportImportMessage.MessageTypes.Error)
                    Pnl.CssClass += " dnnFormValidationSummary";
                if (MessageType == ExportImportMessage.MessageTypes.Information)
                    Pnl.CssClass += " dnnFormSuccess";
                if (MessageType == ExportImportMessage.MessageTypes.Warning)
                    Pnl.CssClass += " dnnFormWarning";
            }
        }
    }
}