﻿var ToSexyContent = ToSexyContent || {};
ToSexyContent.Services = ToSexyContent.Services || {};
ToSexyContent.Services.Ajax = function (methodName, opts) {
	var result;
	$.ajax({
		type: "POST",
		contentType: "application/json; charset=utf-8",
		url: "/DesktopModules/ToSIC_SexyContent/API/Services.asmx/" + methodName,
		data: JSON.stringify(opts),
		async: false,
		success: function (data) {
			result = data.d;
		},
	});

	return result;
};

ToSexyContent.ItemForm = {
	File: {
		OpenDialog: function (dialogOpenerId, type, attributeStaticName, portalId) {
			switch (type) {
				case "ImageManager":
					$find(dialogOpenerId).open('ImageManager', { CssClasses: [], AttributeStaticName: attributeStaticName, PortalId: portalId });
					break;
				case "DocumentManager":
					var args = new Telerik.Web.UI.EditorCommandEventArgs("DocumentManager", null, document.createElement("a"));
					args.CssClasses = [];
					args.AttributeStaticName = attributeStaticName;
					args.PortalId = portalId;

					$find(dialogOpenerId).open('DocumentManager', args);
					break;
				case "PagePicker":
					var fieldController = $(".eav-field[data-staticname='" + attributeStaticName + "']")[0].Controller.FieldController;
					var selectedTabId;
					try {
						selectedTabId = fieldController.GetValue().match(/(\w+):\s?([0-9]+)/i)[2];
					}
					catch (e) { selectedTabId = -1; }
					var pickerContent = $('<div id="PagePicker">Select Page: <select id="ddlPagePicker"></select><div><input id="btnUsePage" type="button" value="ok"/></div></div>');
					var pagePicker = pickerContent.find("#ddlPagePicker");
					pickerContent.dialog({
						modal: true, autoOpen: true, position: "center", dialogClass: "dnnFormPopup", title: "Select Page", close: function () {
							pickerContent.dialog("destroy");
							pickerContent.remove();
						}
					});
					// ToDo: resolve activeLanguage
					var portalTabs = ToSexyContent.Services.Ajax("GetPortalTabs", { portalId: portalId, activeLanguage: "en-us" });
					$.each(portalTabs, function (i, tabInfo) {
						var item = $("<option/>").val(tabInfo.TabID).text(tabInfo.IndentedTabName);
						if (selectedTabId == tabInfo.TabID)
							item.prop("selected", true);
						pagePicker.append(item);
					});
					pickerContent.find("#btnUsePage").click(function () {
						var selectedValue = pagePicker.val();
						var url = "";
						if (selectedValue && selectedValue != -1)
							url = "Page:" + selectedValue;
						fieldController.SetValue(url);
						pickerContent.dialog("destroy");
						pickerContent.remove();
					});
					break;
			}
		},
		ImageManagerCallback: function (sender, args) {
			if (!args)
				return false;

			var path = args.value[0] == null ? args.value.getAttribute("src", 2) : args.value[0].getAttribute("src", 2);
			var url = path.indexOf("%") != -1 ? decodeURIComponent(path) : path;
			var fileId = ToSexyContent.ItemForm.File.GetFileIdByUrl(sender.ClientParameters.PortalId, url.replace("/Portals/" + sender.ClientParameters.PortalId + "/", ""));
			if (fileId)
				url = "FileId:" + fileId;

			$(".eav-field[data-staticname='" + sender.ClientParameters.AttributeStaticName + "']")[0].Controller.FieldController.SetValue(url);
		},
		DocumentManagerCallback: function (sender, args) {
			if (!args)
				return false;

			var url = args.value.getAttribute("href", 2);
			var fileId = ToSexyContent.ItemForm.File.GetFileIdByUrl(sender.ClientParameters.PortalId, url.replace("/Portals/" + sender.ClientParameters.PortalId + "/", ""));
			if (fileId)
				url = "FileId:" + fileId;

			$(".eav-field[data-staticname='" + sender.ClientParameters.AttributeStaticName + "']")[0].Controller.FieldController.SetValue(url);
		},
		GetFileIdByUrl: function (portalId, relativePath) {
			var fileInfo = ToSexyContent.Services.Ajax("GetFileByPath", { portalId: portalId, relativePath: relativePath });
			try {
				return fileInfo.FileId;
			} catch (e) {
				return null;
			}
		},
		GetFilePathById: function (fileId) {
			var fileInfo = ToSexyContent.Services.Ajax("GetFileById", { fileId: fileId });
			try {
				return fileInfo.RelativePath;
			} catch (e) {
				return null;
			}
		},
		TestLink: function (attributeStaticName, portalHome, applicationPath) {
			var url = $(".eav-field[data-staticname='" + attributeStaticName + "']")[0].Controller.FieldController.GetValue();
			if (url) {
				var targetUrl = url;
				var urlMatch = url.match(/(\w+):\s?([0-9]+)/i);
				if (urlMatch != null) {
					switch (urlMatch[1].toLowerCase()) {
						case "fileid":
							var filePath = ToSexyContent.ItemForm.File.GetFilePathById(urlMatch[2]);
							if (filePath == null) {
								alert("Cannot resolve " + url);
								return;
							}
							targetUrl = portalHome + filePath;
							break;
						case "page":
							targetUrl = applicationPath + "?TabId=" + urlMatch[2];
							break;
					}
				}

				window.open(targetUrl);
			}
		},

	}
};