﻿using System;
using System.Collections.Specialized;
using System.Web.UI;
using System.Linq;
using System.Web.UI.WebControls;

namespace ToSic.Eav.ManagementUI
{
    public partial class Number_EditCustom : ManagementUI.FieldTemplateUserControl
    {
        protected global::DotNetNuke.UI.UserControls.LabelControl FieldLabel;

        // Meta Data Keys
        private string MetaDataDefaultValueKey = "DefaultValue";
        private string MetaDataIsRequiredKey = "IsRequired";
        private string MetaDataLengthKey = "Length";
        private string MetaDataNotesKey = "Notes";
        private string MetaDataNameKey = "Name";

        protected void Page_Load(object sender, EventArgs e)
        {
            if (FieldValueEditString == null)
                TextBox1.Text = MetaData.ContainsKey(MetaDataDefaultValueKey) ? MetaData[MetaDataDefaultValueKey][DimensionIds].ToString() : "";
            else
                TextBox1.Text = FieldValueEditString;

            if (MetaData.ContainsKey(MetaDataIsRequiredKey) && ((IAttribute<bool?>)MetaData[MetaDataIsRequiredKey]).Typed[DimensionIds].Value)
                TextBox1.CssClass += " dnnFormRequired";

            if (MetaData.ContainsKey(MetaDataLengthKey))
                TextBox1.MaxLength = int.Parse(MetaData[MetaDataLengthKey][DimensionIds].ToString());

            TextBox1.ToolTip = MetaData.ContainsKey(MetaDataNotesKey) ? MetaData[MetaDataNotesKey][DimensionIds].ToString() : "";

            if (ShowDataControlOnly)
                FieldLabel.Visible = false;
        }

        protected override void OnPreRender(EventArgs e)
        {
            if (!IsPostBack)
            {
                DataBind();
            }

            FieldLabel.Text = MetaData.ContainsKey(MetaDataNameKey) ? MetaData[MetaDataNameKey][DimensionIds].ToString() : Attribute.StaticName;
            FieldLabel.HelpText = MetaData.ContainsKey(MetaDataNotesKey) ? MetaData[MetaDataNotesKey][DimensionIds].ToString() : "";
            valFieldValue.Enabled = MetaData.ContainsKey(MetaDataIsRequiredKey) && ((IAttribute<bool?>)MetaData[MetaDataIsRequiredKey]).Typed[DimensionIds].Value;
            base.OnPreRender(e);
        }

        public override object Value
        {
            get { return TextBox1.Text; }
        }


        public override Control DataControl
        {
            get
            {
                return TextBox1;
            }
        }

    }
}
